/***************************************************************************
                          maptile.h  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MAPTILE_H
#define MAPTILE_H
#include "global_types.h"

/**
  *@author funthing (Matthias Zisler)
  */
class Map;
class CL_Surface;
class Timer;

class Maptile
{
public: 
	Maptile(int _x, int _y, WorldType _wt, Map* _map);
	~Maptile();

	virtual void show()=0;
	virtual void act()=0;
	virtual void fit();

	MaptileType get_type();
	int get_x();
	int get_y();

	void set_blocking(bool b);
	bool is_blocking();
	bool is_fallt();

	bool get_digged();
	bool delete_me();
	void set_delme();

protected:

	int x, y, spr;
	bool blocking, fallt, delme;
	MaptileType mt;
	WorldType wt;
	Map* map;
	CL_Surface* sur;
	Timer* digtimer;
	bool digged;
};

#endif
