/***************************************************************************
                          controller.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "controller.h"
#include "player.h"
#include "config.h"

Controller::Controller(Player* player)
{
	if(player->get_t()==true)
	offset=9;
	else
	offset=0;
	pickup=false;
	locked=false;
}
Controller::~Controller()
{
}

bool Controller::is_left()
{
	if(!locked)
	return CL_Keyboard::get_keycode(Config::keys[0+offset]);
	else
	return false;
}
bool Controller::is_right()
{
	if(!locked)
	return CL_Keyboard::get_keycode(Config::keys[1+offset]);
	else
	return false;
}
bool Controller::is_up()
{
	if(!locked)
	return CL_Keyboard::get_keycode(Config::keys[2+offset]);
	else
	return false;
}
bool Controller::is_down()
{
	if(!locked)
	return CL_Keyboard::get_keycode(Config::keys[3+offset]);
	else
	return false;
}
bool Controller::is_digleft()
{
	return CL_Keyboard::get_keycode(Config::keys[4+offset]);
}
bool Controller::is_digright()
{

	return CL_Keyboard::get_keycode(Config::keys[5+offset]);

}
bool Controller::is_pickup()
{
	if(CL_Keyboard::get_keycode(Config::keys[6+offset]) && pickup==false)
	{
		pickup=true;
		return true;
	}
	else if(!CL_Keyboard::get_keycode(Config::keys[6+offset]))
	{
		pickup=false;
	}

	return 0;
}
bool Controller::is_use()
{
	return CL_Keyboard::get_keycode(Config::keys[7+offset]);
}
bool Controller::is_bomb()
{
	return CL_Keyboard::get_keycode(Config::keys[8+offset]);
}
bool Controller::is_suicide()
{
	if(CL_Keyboard::get_keycode(Config::keys[8+offset]) && CL_Keyboard::get_keycode(CL_KEY_RCTRL))
	return true;
	else
	return false;
}
void Controller::set_locked(bool lock)
{
	locked=lock;
}
bool Controller::is_locked()
{
	return locked;
}